package application.app.controller
{
	import application.app.model.RPGProxySound;

	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;

	
	/**
	 * Commande qui exécute d'autres sous-commandes
	 * 
	 * 
	 * @author matth
	 */
	public class SoundActionCommand extends SimpleCommand implements ICommand
    {
 		
 		/**
 		 * Evènement ApplicationFacade.COMMAND_LOAD_MENU reçu.
 		 * Excécution du code souhaité - chargement des données du model.
 		 * 
 		 */
        override public function execute(note:INotification):void
        {
			var sAction:String = note.getBody() as String;
			
			var oProxySound:RPGProxySound = facade.retrieveProxy(RPGProxySound.NAME) as RPGProxySound;
			
			switch(sAction)
			{
				case RPGProxySound.HERO_JUMP:
					oProxySound.startJumpSound();
					break;
					
				case RPGProxySound.PIECE_WIN:
					oProxySound.startPieceSound();
					break;	
				
				case RPGProxySound.ENNEMI_DEAD:
					oProxySound.startEnnemiDeadSound();
					break;	
				
				case RPGProxySound.PLAYER_DEAD:
					oProxySound.startPlayerDeadSound();
					break;		
				
				case RPGProxySound.PLAYER_GAME_OVER:
					oProxySound.startPlayerGameOverSound();
					break;	
				
				case RPGProxySound.PLAYER_WIN:
					oProxySound.startPlayerWinSound();
					break;	
							
				default:
			}
			
			
        }
 
    }


}
