package application.app.model
{
	import flash.display.Stage;
	import flash.net.navigateToURL;

	import flash.net.URLRequest;
	import flash.events.Event;

	
	import com.demonsters.debugger.MonsterDebugger;

	import application.app.ApplicationFacade;
	
	import org.puremvc.as3.interfaces.IProxy;
	import org.puremvc.as3.patterns.proxy.Proxy;

	
	/**
	 * Lance la récupération des données de notre application
	 * pour les envoyer à notre model.
	 * 
	 * @author matth
	 */
	 public class RPGProxy extends Proxy implements IProxy
    {
		public static const NAME : String = "RPGProxy";
		
		// le héro a perdu, il lui reste des vies, redémarre le niveau au début
		public static const RESTART_LEVEL : String = "onRestartLevel";
		public static const END_LEVEL : String = "onFinishLevel";
 		
		private var stageAppli : Stage;
		
        public function RPGProxy(stage:Stage)
        {
            super(NAME);
            stageAppli = stage;
			setupModel();
		}
		
		
		/**
		 * Préparation de la connexionb remonting.
		 * 
		 */
		private function setupModel() : void
		{
			MonsterDebugger.trace(this, "setupModel Master");
		}
		
		
		/**
		 * Informe toutes les vues abonnées.
		 * 
		 */
		private function onFrame(event : Event) : void
		{
			sendNotification(ApplicationFacade.ON_ENTER_FRAME);
		}
		

		/**
		 * écouteur sur chaque image par seconde
		 * 
		 */
		public function startFrame() : void
		{
			stageAppli.addEventListener(Event.ENTER_FRAME, onFrame);
		}
				
		/**
		 * Appel par une commande.
		 * GameOver ou Gagné.
		 * 
		 */
		public function stopFrame() : void
		{
			stageAppli.removeEventListener(Event.ENTER_FRAME, onFrame);
		}


		public function  get stage() : Stage
		{
			return stageAppli;
		}

 			
		/**
		 * Appel du lien.
		 * 
		 */
		public function onItemSelectedMenuContext(url : String) : void
		{
			navigateToURL(new URLRequest(url), "_blank");
		}
		
    }

}
