package application.app.view
{
	
	import application.app.ApplicationFacade;
	import com.as3facile.DefaultButton;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;


	/**
	 * Permet de construire notre menu et d'interagir avec nos composants graphiques.
	 * 
	 * @author matth
	 */
	public class ViewGagne extends Mediator implements IMediator
	{
		public static const NAME : String = "ViewGagne";

		private var oBtnStartGame : DefaultButton;
		private var oView : Sprite;
		
		public function ViewGagne (viewComponent : Object)
		{
			super(NAME, viewComponent);

			setupUi();
		}

		/**
		 * Initialisation de l'interface utilisateur.
		 * 
		 */
		private function setupUi() : void
		{
			oView = new Gagne();
			oView.visible = false;
			oView.x=5;
			oView.y=27;
			stageV.addChild(oView);
			
			// Création du bouton Rejouer
			oBtnStartGame = new DefaultButton();
			oBtnStartGame.getObject().label = "Commencer";
			oBtnStartGame.getObject().x = 169;
			oBtnStartGame.getObject().y = 75;
			oBtnStartGame.getObject().addEventListener ( MouseEvent.CLICK, onStartGame );
			stageV.addChild(oBtnStartGame);
		}
		
		
		/**
		 * Nouvelle partie.
		 * 
		 */
		private function onStartGame(event : MouseEvent) : void
		{
			oView.visible = oBtnStartGame.visible = false;
			sendNotification(ApplicationFacade.COMMAND_START_GAME);// démarre une nouvelle partie
		}
		
		
		/**
		 * Appel par une commande.
		 * 
		 */
		public function seeView() : void 
		{
			oBtnStartGame.getObject().label = "Continuer ?";
			oView.visible = oBtnStartGame.visible = true;
		}

		/**
		 * Transtypage du viewComponent en son type actuel.
		 * 
		 */
		protected function get stageV() : Sprite
		{
			return viewComponent as Sprite;
		}

		/**
		 * Notifications attendues.
		 * 
		 */
		override public function listNotificationInterests() : Array
		{
			return [];
		}

		/**
		 * Gestion des notifications.
		 * 
		 */
		override public function handleNotification(note : INotification) : void
		{
			switch (note.getName())
			{
				/*case ApplicationFacade.GAME_OVER:
					oView.visible = true;
					break;*/
			}
		}
	}
}
